
read_kbd:

	in al,64h		; read status byte
	and al,01h		; wait for output buffer to be full
	jz read_kbd

	in al,60h		; read scancode byte

	cmp al,02h
	je near .q
	cmp al,03h
	je near .w
	cmp al,04h
	je near .e
	cmp al,05h
	je near .r
	cmp al,06h
	je near .t
	cmp al,07h
	je near .y
	cmp al,08h
	je near .u
	cmp al,09h
	je near .i
	cmp al,0ah
	je near .o
	cmp al,0bh
	je near .p

	cmp al,10h
	je near .q
	cmp al,11h
	je near .w
	cmp al,12h
	je near .e
	cmp al,13h
	je near .r
	cmp al,14h
	je near .t
	cmp al,15h
	je near .y
	cmp al,16h
	je near .u
	cmp al,17h
	je near .i
	cmp al,18h
	je near .o
	cmp al,19h
	je near .p

	cmp al,1eh
	je near .a
	cmp al,1fh
	je near .s
	cmp al,20h
	je near .d
	cmp al,21h
	je near .f
	cmp al,22h
	je near .g
	cmp al,23h
	je near .h
	cmp al,24h
	je near .j
	cmp al,25h
	je near .k
	cmp al,26h
	je near .l

	cmp al,2ch
	je near .z
	cmp al,2dh
	je near .x
	cmp al,2eh
	je near .c
	cmp al,2fh
	je near .v
	cmp al,30h
	je near .b
	cmp al,31h
	je near .n
	cmp al,32h
	je near .m

	cmp al,0eh
	je near .backspace

	cmp al,39h
	je near .space

	cmp al,1ch
	je near .enter

	jmp read_kbd

.q:

	mov bl,'q'
	call putch32
	jmp read_kbd

.w:
	
	mov bl,'w'
	call putch32
	jmp read_kbd

.e:
	
	mov bl,'e'
	call putch32
	jmp read_kbd

.r:
	
	mov bl,'r'
	call putch32
	jmp read_kbd

.t:
	
	mov bl,'t'
	call putch32
	jmp read_kbd

.y:
	
	mov bl,'y'
	call putch32
	jmp read_kbd

.u:
	
	mov bl,'u'
	call putch32
	jmp read_kbd

.i:
	
	mov bl,'i'
	call putch32
	jmp read_kbd

.o:
	
	mov bl,'o'
	call putch32
	jmp read_kbd

.p:
	
	mov bl,'p'
	call putch32
	jmp read_kbd

.a:
	
	mov bl,'a'
	call putch32
	jmp read_kbd

.s:
	
	mov bl,'s'
	call putch32
	jmp read_kbd

.d:
	
	mov bl,'d'
	call putch32
	jmp read_kbd

.f:
	
	mov bl,'f'
	call putch32
	jmp read_kbd

.g:
	
	mov bl,'g'
	call putch32
	jmp read_kbd

.h:
	
	mov bl,'h'
	call putch32
	jmp read_kbd

.j:
	
	mov bl,'j'
	call putch32
	jmp read_kbd

.k:
	
	mov bl,'k'
	call putch32
	jmp read_kbd

.l:
	
	mov bl,'l'
	call putch32
	jmp read_kbd

.z:
	
	mov bl,'z'
	call putch32
	jmp read_kbd

.x:
	
	mov bl,'x'
	call putch32
	jmp read_kbd

.c:
	
	mov bl,'c'
	call putch32
	jmp read_kbd

.v:
	
	mov bl,'v'
	call putch32
	jmp read_kbd

.b:
	
	mov bl,'b'
	call putch32
	jmp read_kbd

.n:
	
	mov bl,'n'
	call putch32
	jmp read_kbd

.m:
	
	mov bl,'m'
	call putch32
	jmp read_kbd

.space:
	
	mov bl,' '
	call putch32
	jmp read_kbd

.enter:
	

	mov bl,0dh
	call putch32
	mov bl,0ah
	call putch32
	jmp read_kbd



.backspace:			; this is a fun little thing

	mov bl,08h
	call putch32
	mov bl,20h
	call putch32
	mov bl,08h
	call putch32
	
	jmp read_kbd